﻿using System;
using System.Linq;
using System.Windows.Controls;
using Telerik.Windows.Persistence.Services;
using Telerik.Windows.Controls;
using Telerik.Windows.Persistence;
using Telerik.Windows.Persistence.Storage;
using System.Windows;

namespace GridViewSerialization
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			// register the custom property provider for the RadGridView:
			ServiceProvider.RegisterPersistenceProvider<ICustomPropertyProvider>(typeof(RadGridView), new GridViewCustomPropertyProvider());
			this.DataContext = ExamplesDB.GetCustomers();

            Loaded += new System.Windows.RoutedEventHandler(MainPage_Loaded);
            Unloaded += new System.Windows.RoutedEventHandler(MainPage_Unloaded);

            Application.Current.Exit += (s, e) =>
            {
                SaveState();
            };

		}

        void MainPage_Unloaded(object sender, System.Windows.RoutedEventArgs e)
        {
            SaveState();
        }

        void MainPage_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            //LoadState();
        }

        private static void SaveState()
        {
            IsolatedStorageProvider isoStorageProvider = new IsolatedStorageProvider();
            isoStorageProvider.SaveToStorage();
        }
        private static void LoadState()
        {
            IsolatedStorageProvider isoStorageProvider = new IsolatedStorageProvider();
            isoStorageProvider.LoadFromStorage();
        }

        private void RadGridView_Loaded(object sender, RoutedEventArgs e)
        {
            Dispatcher.BeginInvoke(new Action(() =>
            {
                LoadState();
            }));
        }
	}
}
